Redmine - Defect #10675

"Submit and continue" is broken
2012-04-16 11:29 - Etienne Massip

Status: Closed Start date:

Priority: Normal Due date:

Assignee: % Done: 0%

Category: Issues Estimated time: 0.00 hour

Target version: 1.4.1

Resolution: Fixed Affected version: 1.4.0

Description

"Submit and continue" button behaves just as "Submit" at issue creation.

Related issues:

Related to Redmine - Feature #6555: Double-click on "Submit" and "Save" butto... Closed 2010-10-01

Associated revisions

Revision 9442 - 2012-04-19 09:17 - Jean-Philippe Lang
Fixed that "Create and continue" buttons are broken by r9391 (#10675).

History

#1 - 2012-04-16 11:30 - Etienne Massip
- Affected version (unused) set to 1.4.0

- Affected version set to 1.4.0

#2 - 2012-04-16 12:11 - Etienne Massip

Reproduced with FF & Chrome, works fine on www.redmine.org but not on http:/xxx.m.redmine.org.

According to my log, worked fine on r9381.
Since then, looks like submit control name is no more in POST form data.

#3 - 2012-04-16 22:24 - Etienne Massip
Guess it's due to r9391 for #6555 wich disables input[type=submit].

#4 - 2012-04-17 09:35 - Etienne Massip

Following replacement might be overkill but works on Chrome & IE8:

function addFormObserversForDoubleSubmit () {

$$ ('form[method=post]') .each (function (form) {
form.on ('submit', function (form_submission) {
alreadySubmitted = (form.getStorage().get ('submitting') == true);

if (alreadySubmitted)
form_submission.stop();
else
form.getStorage () .set ('submitting', true);

#5 - 2012-04-17 09:41 - Etienne Massip

Shorter, not tested:

function addFormObserversForDoubleSubmit () {
$S$ ('form[method=post] ') .each (function (form) {
form.on ('submit', function (form_submission) {
if (form.getStorage () .get ('submitted"'))
form_submission.stop();
else

2025-05-02

1/2



http://www.redmine.org
http://xxx.m.redmine.org
https://www.redmine.org/projects/redmine/repository/svn/revisions/9381
https://www.redmine.org/projects/redmine/repository/svn/revisions/9391
https://www.redmine.org/issues/6555

form.getStorage () .set ('submitted', true);

#6 - 2012-04-18 07:48 - Jean-Philippe Lang

- Target version changed from Candidate for next minor release to 1.4.1

#7 - 2012-04-18 08:52 - Etienne Massip

Note: of course the above code will break any form in the application which should be allowed to be submitted more than once.

#8 - 2012-04-18 13:51 - Jean-Philippe Lang
The shorter patch works fine for with FF11, latest Chrome and IE6/9 as well. Please commit.

Etienne Massip wrote:

Note: of course the above code will break any form in the application which should be allowed to be submitted more than once.

So did r9391. We can add a special class on forms that need to be submitted more than once.

#9 - 2012-04-18 15:11 - Etienne Massip

Jean-Philippe Lang wrote:

So did r9391. We can add a special class on forms that need to be submitted more than once.

Are there such forms? | was thinking of some Rails dark magic reloading only a part of the form DOM via XHR on form submission, but | don't know if
it exists?

#10 - 2012-04-18 19:39 - Jean-Philippe Lang
| don't think there is any of these forms in the core but it might be desirable, just in case a plugin needs it. Something like:
function addFormObserversForDoubleSubmit () {

$S$('form[method=post]"') .each(function(form) {

if (!'form.hasClassName ('multiple-submit')) {
form.on ('submit', function (form_submission) {
if (form.getStorage () .get ('submitted"'))
form_submission.stop();

else
form.getStorage () .set ('submitted', true);

#11 - 2012-04-18 19:59 - Etienne Massip

Think you've got the best answer.

#12 - 2012-04-19 09:19 - Jean-Philippe Lang
- Status changed from Confirmed to Closed

- Resolution set to Fixed

Fix committed, thanks.
